screenmode=CommandLine()

If screenmode=0 Then screenmode=1

AppTitle "Balloon Pop"
Graphics 640,480,0,screenmode
SetBuffer BackBuffer()

SeedRnd MilliSecs()

popsound=LoadSound("Media\pop.wav")

gamefont=LoadFont("Comic Sans MS",22,True,False,False)

backgroundimage=LoadImage("Media\Background.png")
titleimage=LoadImage("Media\Title.png")
levelupimage=LoadImage("Media\Levelup.png")
gameoverimage=LoadImage("Media\Gameover.png")
aboutimage=LoadImage("Media\About.png")

ball1=LoadImage("Media\red.bmp")
ball2=LoadImage("Media\blue.bmp")
ball3=LoadImage("Media\green.bmp")
ball4=LoadImage("Media\yellow.bmp")
ball5=LoadImage("Media\purple.bmp")
ball6=LoadImage("Media\black.bmp")
ball7=LoadImage("Media\silver.bmp")

MaskImage ball1,224,128,192
MaskImage ball2,224,128,192
MaskImage ball3,224,128,192
MaskImage ball4,224,128,192
MaskImage ball5,224,128,192
MaskImage ball6,224,128,192
MaskImage ball7,224,128,192

chnBackground=PlayMusic("Media\Song.s3m")

Gosub init

Gosub setup

Gosub menu

End

.init

	Const maxballs=1000

	Dim ballx(maxballs)
	Dim bally(maxballs)
	Dim balla(maxballs)
	Dim ballstart(maxballs)
	Dim balldelay(maxballs)
	Dim ballc(maxballs)

Return

.setup
	
	filein=ReadFile("highscores.dat")
	highscore=ReadInt(filein)
	CloseFile(filein)
	
	speed=1
	score=0
	level=1
	missed=0
	balls=level*5

	Gosub newballs
	Gosub menu
	
Return

.menu
	
	Repeat 

		Cls
		DrawImage titleimage,0,0
		SetFont gamefont
		Color 0,0,0
		Text 500,420,"High Score: "+highscore
		Flip
		WaitMouse()
	
		If MouseHit(1) Then 
	
			If MouseX()>293 And MouseX()<346 And MouseY()>343 And MouseY()<367 Then 
		
				Gosub gameloop
				Gosub setup
			
			EndIf
			
			If MouseX()>285 And MouseX()<351 And MouseY()>376 And MouseY()<400 Then
			
				Cls
				DrawImage aboutimage,0,0
				Flip
				WaitMouse()
				
			EndIf
			
			If MouseX()>293 And MouseX()<346 And MouseY()>409 And MouseY()<432 Then
			
				End
				
			EndIf
		
		EndIf
		
	Until KeyHit(1)
	
	
Return

.gameloop

	Repeat
	
		Cls
		
		DrawImage backgroundimage,0,0
		
		mouseclicked=MouseHit(1)
		count=0
		
		For ball=0 To balls-1

			If balla(ball)=1 And MilliSecs()>ballstart(ball)+balldelay(ball) Then
			
				If bally(ball)>0 Then

					bally(ball)=bally(ball)-speed
					
				EndIf
						
				If mouseclicked And MouseX()>ballx(ball) And MouseX()<ballx(ball)+20 And MouseY()>bally(ball) And MouseY()<bally(ball)+20 Then
				
					balla(ball)=0
					score=score+1
					mouseclicked=0
					PlaySound popsound
				
				EndIf					
			
				If bally(ball)<=20 Then
				
					balla(ball)=0
					missed=missed+1

				EndIf
			
			EndIf
			
			If balla(ball)=1 Then 
			
				count=count+1
				
				Select ballc(ball)
				
					Case 0
						DrawImage ball1,ballx(ball),bally(ball)	
						
					Case 1
						DrawImage ball2,ballx(ball),bally(ball)
						
					Case 2
						DrawImage ball3,ballx(ball),bally(ball)
						
					Case 3
						DrawImage ball4,ballx(ball),bally(ball)
						
					Case 4
						DrawImage ball5,ballx(ball),bally(ball)
						
					Case 5
						DrawImage ball6,ballx(ball),bally(ball)
						
					Case 6
						DrawImage ball7,ballx(ball),bally(ball)
				
				End Select
				
			EndIf

		Next
		
		If count=0 And missed<3 Then
		
			level=level+1
			balls=level*5
			
			Cls
			DrawImage levelupimage,0,0
			Text 260,0,"Click to continue"
			Flip
			Delay 1000
			FlushMouse
			WaitMouse()
			
			Gosub newballs
		
		EndIf
		
		If missed>2 Then
		
			Cls
			DrawImage gameoverimage,0,0
			Text 5,0,"Score: "+score
			Text 100,0,"Level: "+level
			Text 180,0,"High score: "+highscore
		
			
			If score>highscore Then
			
				highscore=score
				
				Text 320,0,"New high score!"
				
				fileout=WriteFile("highscores.dat")
				WriteInt(fileout,highscore)
				CloseFile(fileout)
				
			EndIf
			
			Flip
			Delay 1000
			FlushMouse
			WaitMouse()
			
			Gosub setup
			
		EndIf
		
		Text 5,0,"Score: "+score
		Text 100,0,"Level: "+level
		Text 200,0,"Missed: "+missed
		Text 500,0,"High Score: "+highscore
		
		If KeyHit(25) Then
		
			Text 320,0,"Click to continue."
			Flip
			WaitMouse()
		
		EndIf
		
		Text 320,0,"Press P to pause."		
		
		Flip
	
	Until KeyHit(1)
	
Return

.newballs
		
	For ball=0 To balls-1
	
		ballx(ball)=Rnd(20,620)
		bally(ball)=420
		balla(ball)=1
		ballstart(ball)=MilliSecs()
		balldelay(ball)=Rnd(0,5000+level*100)
		ballc(ball)=Rnd(0,6)
		
	Next

Return